GENSNPT.prg

** ability to generate a program file which
** contains all of the code snippet procedures from
** a screen file (.scx). These are the VALIDs,
** WHENs and READ clauses converted from code
** snippets. It is to be used to generate a
** controlling screen program.
**
** SCX parameters:
** objtype:
**     1 = READ
**    11 = Scrollable list
**    12 = Push Buttons
**    13 = Radio Buttons
**    14 = CheckBox
**    15 = GET/EDIT
**    16 = Popup
**    20 = Invisible Button
** ????type:
**     0 = Expression (already external)
**     1 = Procedure (snippet)
**
** gensnpt parameters:
** screen = name of the screen file to be used
** program = name of program file to be generated.
**           If none is passed the name of the
**           screen will be used. If the program
**           already exists, the procedures
**           will be added to the program code.
PARAMETERS screen,program

** verify the parameters that were passed

IF TYPE("SCREEN") # "C"
  ??CHR(7)
  WAIT WINDOW "NO SCREEN NAME. UNABLE TO CONTINUE"
  RETURN
ENDIF no screen name passed

** use ALLTRIM to remove any spaces added to name
IF TYPE("PROGRAM") # "C"
  program = ALLTRIM((screen))+".PRG"
ELSE
  program = ALLTRIM((program))+".PRG"
ENDIF no program name passed

** initialize file for textmerge
SET TEXTMERGE ON
SET TEXTMERGE TO (program) ADDITIVE

** open the appropriate screen table
USE (screen)+".SCX"
SET CONSOLE OFF

** check all records in the SCX for code snippets
SCAN

  IF !EMPTY(when) AND whentype = 1
    IF objtype = 1
      proc = "readwhen"
    ELSE
      proc = procname()
      proc = "W"+(proc)
      DO writeproc WITH proc,when
    ENDIF
    REPLACE whentype WITH 0,when WITH (proc)+"()"
  ENDIF when procedure

  IF !EMPTY(show)
    IF LEFT(show,11) != "DO readshow"
    ** I haven't been here
      DO writeproc WITH "readshow",show
      REPLACE show WITH "DO readshow"
    ENDIF
    REPLACE showtype WITH 1
  ENDIF read show procedure

  IF !EMPTY(valid) AND validtype = 1
    IF objtype = 1   &&this is the read
      proc = "readvalid"
    ELSE
      proc = procname()
      proc = "V"+(proc)
    ENDIF read valid
    DO writeproc WITH proc,valid
    REPLACE validtype WITH 0,valid WITH (proc)+"()"
  ENDIF valid procedure

  IF !EMPTY(activate) AND activtype = 1
    proc = "readacti"
    DO writeproc WITH proc,activate
    REPLACE activtype WITH 0,;
            activate WITH (proc)+"()"
  ENDIF read activate procedure

  IF !EMPTY(deactivate) AND deacttype = 1
    proc = "readdeac"
    DO writeproc WITH proc,deactivate
    REPLACE deacttype WITH 0,;
            deactivate WITH (proc)+"()"
  ENDIF read deactivate procedure

ENDSCAN look through the screen database

** close the screen table and set textmerge off
USE IN (screen)
SET TEXTMERGE TO
SET TEXTMERGE OFF
SET CONSOLE ON

PROCEDURE procname
** determine the name of the procedure
** name = the field in the SCX which contains the
**        memory variable or field name
IF "."$(name)
  fname = SUBSTR(ALLTRIM(name),AT(".",name)+1)
ELSE
  fname = ALLTRIM(name)
ENDIF field alias or memory variable identifier found
RETURN fname

PROCEDURE writeproc
PARAMETERS procname,action

** use textmerge to send to the output file the
** word PROCEDURE and the name of the procedure
** (e.g. readshow) in lower case
** then write out the contents of the memo field
** from the SCX which contains the actual snippet.
** Carriage returns are honored by textmerge so
** parsing the memo field is unnecessary

\PROCEDURE <LOWER(procname)>
\<action>
\
RETURN


